import { InputError } from '@roots/bud-support/errors';
import isArray from '@roots/bud-support/isArray';
export const compilePaths = function (sources, rules) {
    this.hooks.action(`build.before`, async (bud) => {
        const keys = (rules ??
            Object.keys(bud.build.rules));
        const matches = keys.map(rule => {
            const match = bud.build.getRule(rule);
            if (!match) {
                throw new InputError(`bud.compilePaths: \`${rule}\` is not a valid rule name.`);
            }
            return match;
        });
        matches.map(rule => {
            bud.api.logger.log(`setting compile paths for ${rule.getTest()}`);
            rule.setInclude(isArray(sources) ? sources : [sources]);
        });
    });
    return this;
};
